#ifndef DOCUMENT_CLIENT_H
#define DOCUMENT_CLIENT_H

#include "document.grpc.pb.h"
#include "document.pb.h"
#include <string>
namespace document {

struct DocumentChunkResponse {
    std::string data;
    void* callbackData;
    int errorCode;
    std::string errorMsg;
};

class ChunkStubManager;
class DocumentChunkClient {
public:
  DocumentChunkClient();
  ~DocumentChunkClient();

  DocumentChunkResponse SyncChunkDocument(const std::vector<std::string> &file_paths,
                                   const std::vector<std::string> &chunker_types,
                                   const std::vector<int32_t> &chunk_sizes);

  // 异步分块请求
  void AsyncChunkDocument(
      const std::vector<std::string> &file_paths,
      const std::vector<std::string> &chunker_types,
      const std::vector<int32_t> &chunk_sizes, const std::string &callback_data,
      std::function<void(const ::document::ChunkedResponse &response,
                         const ::grpc::Status &status)>
          callback);

private:
    ChunkStubManager *d_;
    std::unique_ptr<ChunkStubManager> stub_manager_;
    void *callback_data_;
    ::document::ChunkedResponse async_response_;
};

} // namespace document

#endif // DOCUMENT_CLIENT_H