#ifndef GRPC_DOCUMENT_SERVICE_STUB_H
#define GRPC_DOCUMENT_SERVICE_STUB_H

#include "idocument_service_stub.h"
#include <memory>
#include <grpcpp/grpcpp.h>
#include "document.grpc.pb.h"

namespace document {

class GrpcDocumentServiceStub : public IDocumentServiceStub {
public:
    explicit GrpcDocumentServiceStub(std::shared_ptr<grpc::Channel> channel)
        : stub_(::document::DocumentService::NewStub(channel)) {}

    ::grpc::Status ChunkDocument(
        ::grpc::ClientContext* context,
        const ::document::ChunkRequest& request,
        ::document::ChunkedResponse* response) override {
        return stub_->SyncChunkDocument(context, request, response);
    }

    std::unique_ptr<grpc::ClientReader<::document::ChunkedResponse>> AsyncChunkDocument(
        ::grpc::ClientContext* context,
        const ::document::ChunkRequest& request) override {
        return stub_->AsyncChunkDocument(context, request);
    }

private:
    std::unique_ptr<::document::DocumentService::Stub> stub_;
};

}  // namespace document

#endif  // GRPC_DOCUMENT_SERVICE_STUB_H