#ifndef STUB_MANAGER_H
#define STUB_MANAGER_H

#include <grpcpp/grpcpp.h>
#include "document.grpc.pb.h"

namespace document {

class ChunkStubManager {
public:
  // 构造函数
  ChunkStubManager(std::shared_ptr<grpc::Channel> sync_channel,
              std::shared_ptr<grpc::Channel> async_channel);

  // 析构函数
  ~ChunkStubManager();

  // 获取同步存根
  ::document::DocumentService::Stub *GetSyncStub() const;

  // 获取异步存根
  ::document::DocumentService::Stub *GetAsyncStub() const;

private:
  std::unique_ptr<::document::DocumentService::Stub> sync_stub_;
  std::unique_ptr<::document::DocumentService::Stub> async_stub_;
};

} // namespace document

#endif // STUB_MANAGER_H